#ifndef SYSTEM_SYSTEM_H
#define SYSTEM_SYSTEM_H

#include <string>
#include "math/vec.h"

//external

class PSystem {
public:
	virtual void init() = 0;
	virtual void shutdown() = 0;

	virtual void loop(void (*loopCallback)()) = 0;
	virtual void requestExit() = 0;
	
	virtual void setInitDoubleBuffered(bool initDoubleBuffered) = 0;
	virtual void setInitPos(const vec2i &initPos) = 0;
	virtual void setInitSize(const vec2i &initSize) = 0;

	virtual const std::string &getArg(int index) const = 0;
	virtual size_t getArgCount() const = 0;
};

class ISystem : public PSystem {
	PSystem *imp;
public:
	ISystem();
	void setImp(PSystem *_imp);
	virtual void init();
	virtual void shutdown();
	virtual void requestExit();
	virtual void loop(void (*loopCallback)());
	
	virtual void setInitDoubleBuffered(bool initDoubleBuffered) ;
	virtual void setInitPos(const vec2i &initPos);
	virtual void setInitSize(const vec2i &initSize);

	virtual const std::string &getArg(int index) const;
	virtual size_t getArgCount() const;
};

#endif	//SYSTEM_SYSTEM_H
