#include "system/display.h"

void Display::reset() {
	size.set(0,0);
	lastsize.set(0,0);
	newsize.set(0,0);
}

void Display::update() {
	lastsize = size;
	size = newsize;
}

void Display::resize(int w, int h) {
	newsize.set(w,h);
}


IDisplay::IDisplay() : imp(NULL) {}
void IDisplay::setImp(PDisplay *_imp) { imp = _imp; }
void IDisplay::update() {
	assert(imp);
	imp->update();
}
void IDisplay::resize(int w, int h) {
	assert(imp);
	imp->resize(w,h);
}
const vec2i &IDisplay::getSize() const {
	assert(imp);
	return imp->getSize();
}
bool IDisplay::sizeHasChanged() {
	assert(imp);
	return imp->sizeHasChanged();
}
