#ifndef WIN32

#include <assert.h>
#include <iostream>

#include "system/exception.h"
#include "system/linuxtimer.h"
#include "system/timer.h"

using namespace std;

LinuxHiResTimer::LinuxHiResTimer() {
	memset(&tz, 0, sizeof(tz));
	memset(&firstTime, 0, sizeof(firstTime));
}

void LinuxHiResTimer::init() {
	gettimeofday(&firstTime, &tz);
}

double LinuxHiResTimer::getTime() {
	struct timeval tv;
	gettimeofday(&tv, &tz);
	return 
		((double)tv.tv_sec + (double)tv.tv_usec / 1000000.0) -
		((double)firstTime.tv_sec + (double)firstTime.tv_usec / 1000000.0);
	
}

#endif //WIN32
