#include "system/mutex.h"
#include <assert.h>

Mutex::Mutex(bool init) {
	imp = MutexFactory::create(init);
	assert(imp);
}
Mutex::~Mutex() { delete imp; }
bool Mutex::init() { assert(imp); return imp->init(); }
void Mutex::shutdown() { assert(imp); imp->shutdown(); }
void Mutex::lock() { assert(imp); imp->lock(); }
void Mutex::unlock() { assert(imp); imp->unlock(); }

MutexLock::MutexLock(Mutex *_cs) : cs(_cs) {
	assert(cs);
	cs->lock();
}
MutexLock::~MutexLock() {
	cs->unlock();
}
