#include <assert.h>	//NULL
#include "system/system.h"

ISystem::ISystem() : imp(NULL) {}

void ISystem::setImp(PSystem *_imp) {
	imp = _imp;
}
void ISystem::init() {
	assert(imp);
	imp->init();
}
void ISystem::shutdown() {
	assert(imp);
	imp->shutdown();
}
void ISystem::loop(void (*loopCallback)()) {
	assert(imp);
	imp->loop(loopCallback);
}
void ISystem::requestExit() {
	assert(imp);
	imp->requestExit();
}
void ISystem::setInitDoubleBuffered(bool db) {
	assert(imp);
	imp->setInitDoubleBuffered(db);
}
void ISystem::setInitPos(const vec2i &initPos) {
	assert(imp);
	imp->setInitPos(initPos);
}
void ISystem::setInitSize(const vec2i &initSize) {
	assert(imp);
	imp->setInitSize(initSize);
}
const std::string &ISystem::getArg(int index) const {
	assert(imp);
	return imp->getArg(index);
}
size_t ISystem::getArgCount() const {
	assert(imp);
	return imp->getArgCount();
}